// ===============================================================================================
package tetrix;

import javax.swing.*;
import javax.swing.JCheckBoxMenuItem;
import java.awt.*;
import java.awt.event.*;
import java.util.Calendar;
import java.io.*;

// -----------------------------------------------------------------------------

public class main extends JPanel
{ 
  final static String gname="T e t r i x",kenn="tetrix";
  final static String commands[] ={ "neu","laden","speichern","quit","pause","sound",
                                    "hiscore","hireset","hilfe","about" };
  final static String datenpfad=kenn+"/data/"; // ressource!
  final static String configfile="game.ini";
  final static String hilfefile=datenpfad+"hilfe.txt"; // ressource!
  final static int himax=10;
  final static String hilfetext[]=((String) (loadressource(hilfefile))).split("\n");

  static boolean soundon;
  static String hscfile,gamefile,levelfile;
  static int kommando=-1;
  static int punkte[]  =new int[himax+1];
  static String sname[]=new String[himax+1];
  static String datum[]=new String[himax+1];

  static JRadioButtonMenuItem pause=new JRadioButtonMenuItem("Pause");
  static JRadioButtonMenuItem weiter=new JRadioButtonMenuItem("weiter");
  static JRadioButtonMenuItem sou_on=new JRadioButtonMenuItem("Sound on");
  static JRadioButtonMenuItem sou_off=new JRadioButtonMenuItem("Sound off");

  static main      steuerung=new main();
  static spielfeld gamepanel=new spielfeld(steuerung); // als parent uebergeben
  static spiel my_spiel=new spiel(steuerung);

  static ActionListener alist=new ActionListener() { public void actionPerformed(ActionEvent e) { buttonklick(e); } };
  static KeyAdapter keydap=new KeyAdapter() { public void keyPressed(KeyEvent e) { key(e); } };

// Methoden: ---------------------------------------------------------------------------------------------------------
  public static void main(String[] args) { load_config(); init_gui(); set_buttons(); }
  static String get_kennung()   { return kenn; }
  static String get_spielname() { return gname; }
  static void popup(String t) { JOptionPane.showMessageDialog(steuerung,t,"Info:",JOptionPane.INFORMATION_MESSAGE); }

  static void eintrag(int pkt)
  { String t0="Mit "+pkt+" Punkten hast du einen Platz in der Hiscore-Liste erobert.\nBitte gib deinen Namen an: ";
    load_hsc();
    if (pkt>punkte[himax-1])
    { sname[himax]=JOptionPane.showInputDialog(t0); 
      if (sname[himax]!=null) if (sname[himax].length()>0)
      { if (sname[himax].length()>32) sname[himax]=sname[himax].substring(0,32);
        punkte[himax]=pkt;
        datum[himax]=get_datum();
        bubblesort();
        save_hsc();
      }
      gamepanel.aktscreen=1;
    }
    else 
    { popup(""+pkt+" Punkte haben leider nicht gereicht!");
      gamepanel.aktscreen=-1;
    }
  }

// ----------------------------------------------------------------------------------------------------------------

  static void init_gui()
  { JPanel mama=new JPanel(new BorderLayout());
    mama.add(gamepanel);
    JFrame frame=new JFrame(gname);
    JMenuBar my_menu=mach_menubar();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setJMenuBar(my_menu);
    frame.setContentPane(mama);
    frame.setSize(gamepanel.sxmax,gamepanel.symax);
    frame.addKeyListener(keydap); // weiss leider nicht, wie man dem hgamepanel den Fokus gibt - dies klappt wenigstens
    set_buttons();
 //   frame.pack();
    frame.setVisible(true);
  }

  static JMenuBar mach_menubar()
  { JMenuBar menu=new JMenuBar();
    // Dropdown Menus Headers:
    JMenu menu0=new JMenu("Spiel");    menu0.setMnemonic(KeyEvent.VK_0); menu.add(menu0);
    JMenu menu1=new JMenu("Optionen"); menu1.setMnemonic(KeyEvent.VK_1); menu.add(menu1);
    JMenu menu2=new JMenu("Hiscore");  menu2.setMnemonic(KeyEvent.VK_2); menu.add(menu2);
    JMenu menu3=new JMenu("Info");     menu3.setMnemonic(KeyEvent.VK_3); menu.add(menu3);

    // Dropdown Menu 0:
    JMenuItem neu = new JMenuItem("Neu",KeyEvent.VK_N);
    neu.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,InputEvent.CTRL_MASK));
    neu.addActionListener(alist);
    neu.setActionCommand(commands[0]);
    menu0.add(neu);
    JMenuItem laden = new JMenuItem("Laden",KeyEvent.VK_L);
    laden.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L,InputEvent.CTRL_MASK));
    laden.setActionCommand(commands[1]);
    laden.addActionListener(alist);
    menu0.add(laden);
    JMenuItem speichern = new JMenuItem("Speichern",KeyEvent.VK_S);
    speichern.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,InputEvent.CTRL_MASK));
    speichern.setActionCommand(commands[2]);
    speichern.addActionListener(alist);
    menu0.add(speichern);
    menu0.addSeparator();
    JMenuItem quit = new JMenuItem("Quit",KeyEvent.VK_Q);
    quit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,InputEvent.CTRL_MASK));
    quit.addActionListener(alist);
    quit.setActionCommand(commands[3]);
    menu0.add(quit);

    // Dropdown Menu 1:
    pause.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,InputEvent.CTRL_MASK));
    pause.setActionCommand(commands[4]);
    pause.addActionListener(alist);
    menu1.add(pause);
    weiter.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,InputEvent.CTRL_MASK));
    weiter.setActionCommand(commands[4]);
    weiter.addActionListener(alist);
    menu1.add(weiter);
    menu1.addSeparator();
    sou_on.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M,InputEvent.CTRL_MASK));
    sou_on.setActionCommand(commands[5]);
    sou_on.addActionListener(alist);
    menu1.add(sou_on);
    sou_off.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M,InputEvent.CTRL_MASK));
    sou_off.setActionCommand(commands[5]);
    sou_off.addActionListener(alist);
    menu1.add(sou_off);

    // Dropdown Menu 2:
    JMenuItem showhsc = new JMenuItem("zeige Hiscore",KeyEvent.VK_Z);
    showhsc.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,InputEvent.CTRL_MASK));
    showhsc.setActionCommand(commands[6]);
    showhsc.addActionListener(alist);
    menu2.add(showhsc);
    JMenuItem res_hsc = new JMenuItem("Reset Hiscore",KeyEvent.VK_R);
    res_hsc.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,InputEvent.CTRL_MASK));
    res_hsc.setActionCommand(commands[7]);
    res_hsc.addActionListener(alist);
    menu2.add(res_hsc);

    // Dropdown Menu 3:
    JMenuItem hilfe = new JMenuItem("Hilfe",KeyEvent.VK_H);
    hilfe.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H,InputEvent.CTRL_MASK));
    hilfe.setActionCommand(commands[8]);
    hilfe.addActionListener(alist);
    menu3.add(hilfe);
    JMenuItem about = new JMenuItem("About",KeyEvent.VK_A);
    about.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,InputEvent.CTRL_MASK));
    about.setActionCommand(commands[9]);
    about.addActionListener(alist);
    menu3.add(about);

    return menu;
  }

  static void set_buttons()
  { pause.setSelected(my_spiel.pausiert);
    weiter.setSelected(!my_spiel.pausiert);
    sou_on.setSelected(soundon);
    sou_off.setSelected(!soundon);
  }
// ===========================================================================================================
  static String loadfile(String infile)
  { String s,t="";
    try
   {
     BufferedReader in=new BufferedReader(new InputStreamReader(new FileInputStream(infile), "UTF8"));
     do
     { s=in.readLine();
       if (s!=null) t=t+s+"\n";
     }
     while (s!=null);
     in.close();
   }
   catch (IOException e) { System.out.println(infile+" nicht gefunden oder fehlerhaft!\n(Check game.ini)"); }
   return t;
 }

 static String loadressource(String infile)
  { String s,t="";
    try
   { InputStream ips= main.class.getClassLoader().getResourceAsStream(infile);
     BufferedReader in = new BufferedReader(new InputStreamReader(ips,"UTF8"));
     do
     { s=in.readLine();
       if (s!=null) t=t+s+"\n";
     }
     while (s!=null);
     in.close();
   }
   catch (IOException e) { System.out.println("Ressource "+infile+" nicht gefunden oder fehlerhaft!"); }
   return t;
 }

 static void savefile(String outfil,String inhalt)
 { try
   {
     BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfil), "UTF8"));
     out.write(inhalt);
     out.close();
   }
   catch (UnsupportedEncodingException e) { System.out.println("keine UTF-8-Unsterstuetzung!"); }
   catch (IOException e) { System.out.println("Datei "+outfil+" konnte nicht geschrieben werden!"); }
 }

  static void load_config()
  { int i;
    String rec[]=((String)(loadfile(configfile))).split("\n");
    String temp[]=new String[2];
    for (i=0; i<rec.length; i++)
    { temp=rec[i].split("=");
      if (temp[0].equals("soundon")) soundon=(Integer.parseInt(temp[1])>0);
      else if (temp[0].equals("hiscore")) hscfile=temp[1];
      else if (temp[0].equals("gamestore")) gamefile=temp[1];
    }
  }

  static int[] load_spiel()
  { int[] p={ 0,0 };
    String rec[]=((String)(loadfile(gamefile))).split("\n");
    rec=rec[0].split(";");
    p[0]=Integer.parseInt(rec[0]);
    p[1]=Integer.parseInt(rec[1]);
    return p;
  }

  static void save_spiel(int lev,int pkt)
  { String rec=""+lev+";"+pkt+"\n";
    savefile(gamefile,rec);
  }

  static int[][] load_level(int nr)
  { int i,j;
    int xmax=my_spiel.xmax;
    int ymax=my_spiel.ymax;
    int[][]feld=new int[xmax][ymax];
    feld[0][0]=-1;                    // bei Ladefehler
    String lcode="0123456789abcdef";
    String level=datenpfad+"level."+nr;
    String zeile[]=((String)(loadressource(level))).split("\n");
    for (j=0; j<ymax; j++) for (i=0; i<xmax; i++) feld[i][j]=lcode.indexOf(zeile[j].charAt(i));
    return feld;
  }

  static void load_hsc()
  { int i;
    String rec[]=((String)(loadfile(hscfile))).split("\n");
    String temp[]=new String[3];
    for (i=0; i<rec.length; i++)
    { temp=rec[i].split(";");
      punkte[i]=Integer.parseInt(temp[0]);
      datum[i]=temp[1];
      sname[i]=temp[2];
    }
  }

  static void save_hsc()
  { String out="";
    bubblesort();
    for (int i=0; i<himax; i++) out=out+punkte[i]+";"+datum[i]+";"+sname[i]+"\n";
    savefile(hscfile,out); 
  }

  static void reset_hsc()
  { String out="",dat=get_datum();
    for (int i=0; i<himax; i++) out=out+"0;"+dat+";...\n";
    savefile(hscfile,out);
  }

  static void bubblesort()
  { int i,j,k;
    String s;
    boolean tau;
    for (i=0; i<himax; i++) do
    { tau=false;
      for (j=i+1; j<=himax; j++) if (punkte[i]<punkte[j])
      { tau=true;
        k=punkte[i]; punkte[i]=punkte[j]; punkte[j]=k;
        s=datum[i];  datum[i]=datum[j];   datum[j]=s;
        s=sname[i];  sname[i]=sname[j];   sname[j]=s;
      }
    }
    while (tau);
  }

  static String get_datum()
  { 
    Calendar cal=Calendar.getInstance();
    String t="";
    int t1=cal.get(Calendar.DATE);    if (t1<10) t=t+"0"; t=t+t1+".";
    t1=cal.get(Calendar.MONTH)+1;     if (t1<10) t=t+"0"; t=t+t1+".";
    t1=cal.get(Calendar.YEAR)%100;    if (t1<10) t=t+"0"; t=t+t1+" ";
    t1=cal.get(Calendar.HOUR_OF_DAY); if (t1<10) t=t+"0"; t=t+t1+":";
    t1=cal.get(Calendar.MINUTE);      if (t1<10) t=t+"0"; t=t+t1+":";
    t1=cal.get(Calendar.SECOND);      if (t1<10) t=t+"0"; t=t+t1;
    return t;
  }

// ------------------------------------------------------------------------------------------------------
// Sender fuer kommando,aktscreen
  static public void buttonklick(ActionEvent e)
  { String info="Tetrix 1.0 V.071103 by uja\nJava-Application-Version";
    kommando=-1;
    for (int i=0; i<commands.length; i++) if (commands[i] .equals(e.getActionCommand())) kommando=i;
    switch(kommando)
    { case 0: gamepanel.aktscreen=0; my_spiel.neu(0,0); break;
      case 1: int param[]=load_spiel();
              gamepanel.aktscreen=0;
              my_spiel.neu(param[0],param[1]);
              my_spiel.messi="Spiel geladen";
              break;
      case 2: gamepanel.aktscreen=0;
              save_spiel(my_spiel.level,my_spiel.punkte0);
              my_spiel.messi="Spiel gespeichert";
              break;
      case 3: System.exit(0); break;
      case 4: my_spiel.pausiert=!my_spiel.pausiert; gamepanel.aktscreen=0; break;
      case 5: soundon=!soundon; break;
      case 6: my_spiel.pausiert=true; gamepanel.aktscreen=1; break;
      case 7: my_spiel.pausiert=true; reset_hsc(); gamepanel.aktscreen=1; break;
      case 8: my_spiel.pausiert=true; gamepanel.aktscreen=2; break;
      case 9: popup(info); break;
      default: gamepanel.aktscreen=-1;
    }
    set_buttons();
  }

  public static void key(KeyEvent e) 
  {
    switch(e.getKeyCode())
    { case KeyEvent.VK_UP:    my_spiel.key_up();     break;
      case KeyEvent.VK_LEFT:  my_spiel.key_links();  break;
      case KeyEvent.VK_RIGHT: my_spiel.key_rechts(); break;
      case KeyEvent.VK_DOWN:  my_spiel.key_down();   break;
      case KeyEvent.VK_ENTER: my_spiel.key_enter();  break;
    }
  }

}
