// ===============================================================================================
package tetrix;

import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.Graphics.*;
import java.awt.event.*;
import javax.imageio.*;
import java.io.*;
import java.lang.Math;


class spielfeld extends JPanel implements Runnable
{
  Thread thread0;
  int cmax=12;
  int timetic=50;
// Bildschirmparameter:
  final int sxmax=560;
  final int symax=400;
  final int ofx=40;
  final int ofy=0;
  final int dx=16;
  final int dy=16;
  final int astartx=288,bstartx=480; // anpassen!

  int aktscreen=-1;
  main mama;             // parent

  Image pause,gover,bgima,saeule;
  Image ima[]=new Image[cmax];

  BufferedImage buffer=new BufferedImage(sxmax,symax,BufferedImage.TYPE_INT_ARGB);
  Graphics2D g2 = buffer.createGraphics();
  Font font=new Font("SansSerif",Font.BOLD,14);
  FontMetrics metrics = getFontMetrics(font);

  public spielfeld(main parent)
  { mama=parent;
    init_data();
    thread0=new Thread(this);
    thread0.start();
  }

  public void run()
  { while (Thread.currentThread() == thread0)
    { repaint();
      try { Thread.sleep(35); }
      catch (InterruptedException e) { break; }
    }
  }
  public void stop() { thread0=null; }
  public void destroy() { stop(); }
// ------------------------------------------------------------------------------------

  void init_data()
  { String bildpfad="/"+mama.get_kennung()+"/images/";
    bgima=hole_bild(bildpfad+"verlauf_360.jpg");
    saeule=hole_bild(bildpfad+"saeule_48.png");
    pause=hole_bild(bildpfad+"pause.png");
    gover=hole_bild(bildpfad+"gover.png");
    for (int i=0; i<cmax; i++) ima[i]=hole_bild(bildpfad+"tile_"+i+".png");
  }

  public void paintComponent(Graphics g)
  { switch (aktscreen)
    { case 0: mach_spielfeld(g2); g.drawImage(buffer,0,0,null); break;
      case 1: zeige_hsc(g);   break;
      case 2: zeige_hilfe(g); break;
      default: zeige_titel(g);
    }
  }

  Image hole_bild(String filnam)
  { Image ima=null;
    try { ima=ImageIO.read(getClass().getResource(filnam)); }
    catch(Exception io) { System.out.println(filnam+" nicht gefunden oder valide");   }
    return ima;
  }

  void mach_spielfeld(Graphics g)
  { int i,j,k;
    g.drawImage(bgima,0,0,null);
    g.drawImage(saeule,0,0,null);
    g.drawImage(saeule,192,0,null);
    g.drawImage(saeule,sxmax-64,0,null);

    spiel p_game=mama.my_spiel;
    for (i=0; i<p_game.xmax; i++) for (j=0; j<p_game.ymax; j++)
    if (p_game.f[i][j]>0) g.drawImage(ima[p_game.f[i][j]-1],i*dx+ofx,j*dy+ofy,null);
    // aktuelles sprite:
    if (p_game.aktchip.iy>-2) for (i=0; i<4; i++) for (j=0; j<4; j++) if (p_game.aktchip.patt[i][j]>0)
     g.drawImage(ima[p_game.aktchip.patt[i][j]-1],(i+p_game.aktchip.ix)*dx+ofx,(j+p_game.aktchip.iy)*dy+ofy,null);
    // neues Sprite:
    for (i=0; i<4; i++) for (j=0; j<4; j++)
     if (p_game.nextchip.patt[i][j]>0) g.drawImage(ima[p_game.nextchip.patt[i][j]-1],i*dx+astartx,j*dy+96,null);
    // Anzeigen:
    if (p_game.pausiert) g.drawImage(pause,ofx,80,null);
    if (p_game.gover) g.drawImage(gover,ofx,80,null);
    g.setColor(Color.yellow);
    g.setFont(font);
    g.drawString("n\u00e4chster Stein:",astartx,80);
    g.drawString("Level: "+p_game.level,astartx,240);
    g.drawString("Punkte: "+p_game.punkte,astartx,256);
    g.drawString("Reihen: "+p_game.reihen0,astartx,272);
    g.drawString(p_game.messi,astartx,288);
  }

  void zeige_hsc(Graphics g)
  { int line;
    String out;
    mama.load_hsc();
    g.setFont(font);
    g.drawImage(bgima,0,0,null);
    g.setColor(new Color(48,0,16,127));
    line=64;
    for (int i=0; i<mama.himax; i++)
    { g.fillRect(24,line-18,sxmax-128,20);
      line=line+24;
    }
    g.setColor(new Color(0,127,0,191));
    line=64;
    for (int i=0; i<mama.himax; i++)
    { g.drawRect(24,line-18,sxmax-128,20);
      line=line+24;
    }
    line=64;
    g.setColor(Color.yellow);
    g.drawString("HiScore",64,32);
    for (int i=0; i<mama.himax; i++)
    { g.drawString(""+(i+1)+". "+mama.sname[i],48,line);
      out=""+mama.punkte[i]; g.drawString(out,320-metrics.stringWidth(out),line);
      out=mama.datum[i];     g.drawString(out,bstartx-metrics.stringWidth(out),line);
      line=line+24;
    }
    g.drawImage(saeule,0,0,null);
    g.drawImage(saeule,sxmax-64,0,null);
  }

  void zeige_hilfe(Graphics g)
  { g.setFont(font);
    g.drawImage(bgima,0,0,null);
    g.drawImage(saeule,0,0,null);
    g.drawImage(saeule,sxmax-80,0,null);
    g.setColor(new Color(48,0,16,127));
    g.fillRect(40,48,sxmax-112,symax-128);
    g.setColor(new Color(0,127,0,191));
    g.drawRect(40,48,sxmax-112,symax-128);
    g.setColor(Color.yellow);
    g.drawString("Hilfe",64,32);
    for (int i=0; i<mama.hilfetext.length; i++) g.drawString(mama.hilfetext[i],44,80+16*i);
  }

  void zeige_titel(Graphics g)
  { g.setFont(font);
    g.drawImage(bgima,0,0,null);
    g.drawImage(saeule,0,0,null);
    g.drawImage(saeule,sxmax-64,0,null);
    g.setColor(new Color(48,0,16,127));
    g.fillRect(120,160,320,128);
    g.setColor(new Color(0,127,0,191));
    g.drawRect(120,160,320,128);
    g.setColor(Color.yellow);
    g.drawString("Passe fallende Tetronimos in ein Feld",144,192);
    g.drawString("ein - komplette Reihen verschwinden",144,208);
    g.drawString("Spielstart:",144,240);   g.drawString("Ctrl-N",256,240);
    g.drawString("Sound on/off:",144,272); g.drawString("Ctrl-S",256,272);

  }

// =================================================================================================

}
